options(width=100, help_type="html", pager="console", max.print=4999, 
contrasts=c("contr.treatment", "contr.treatment"))

# make object with the names .xxxxx on the working space and attach them with the names xxxxx

.q =function() cat("Use _ icon to suspend R \n")
.setwd=function() cat("Use WorkDir button on TAD \n")


.txp <-
function (...) {
	# since UseMethod does not work for txp
	l=list(...)
	switch(
	   class(l[[1]]),
	   lm=txp.lm(...),
	   data.frame=txp.data.frame(...),
	   txp.default(...)
	   )
}

.txp.data.frame <-
function(x, new=FALSE, plotmode="txp"){
	
x=deparse(substitute(x)) # dataframe name string

attr(x, "new")=new
attr(x, "plotMode")=plotmode

assign(".Out", x, pos=1)
}


.txp.lm <-
function(x, new=FALSE){	
nmx=deparse(substitute(x))
# .Out
assign(".Out", nmx, pos=1) #assign only the name
}
	

.txp.default <-
function(x, new=FALSE){	
attr(x, "new")=new
# .Out
assign(".Out", x, pos=1)
}


.packages<-
function () 
{   
        lib.loc <- .libPaths()   
        pkg <- character()
        title <- character()
        loc=integer()
        
        lib.list=lib.loc[file.exists(lib.loc)]
        
        for (i in 1:length(lib.list)) {
            lib=lib.list[i]
            a <- list.files(lib, all.files = FALSE, full.names = FALSE)
            if(length(a)==0) next
            pfile <- file.path(lib, a, "Meta", "package.rds")
	     for(j in 1:length(pfile)){
	     if(!file.exists(pfile[j])) next;
            title= c(title, readRDS(pfile[j])$DESCRIPTION[["Title"]])         	
            pkg <- c(pkg, a[j])
            loc = c(loc, i)
            }
           
        }

   
	  return(list(pkg, title, loc, lib.loc))

}

.getDependencies <-
function (pkgs, dependencies = c("Depends", "Imports", "LinkingTo"), 
    installed = TRUE, available = TRUE, base = FALSE, recommended = FALSE) 
{
    pkgs.in = pkgs
    if (is.null(dependencies)) 
        return(unique(pkgs))
    dep2 <- c("Depends", "Imports", "LinkingTo")
    if (installed && !available) 
        all.packages <- installed.packages()
    else if (available && !installed) 
        all.packages <- available.packages()
    else all.packages <- as.matrix(smartbind(installed.packages(), 
        available.packages()))
    rownames(all.packages) <- all.packages[, "Package"]
    p0 <- unique(pkgs)
    miss <- !p0 %in% row.names(all.packages)
    if (sum(miss)) {
        warning(sprintf(ngettext(sum(miss), "package %s is not available (for %s)", 
            "packages %s are not available (for %s)"), paste(sQuote(p0[miss]), 
            collapse = ", "), sub(" *\\(.*", "", R.version.string)), 
            domain = NA, call. = FALSE)
        if (sum(miss) == 1L && !is.na(w <- match(tolower(p0[miss]), 
            tolower(row.names(all.packages))))) {
            warning(sprintf("Perhaps you meant %s ?", sQuote(row.names(all.packages)[w])), 
                call. = FALSE, domain = NA)
        }
        flush.console()
    }
    if (!base || !recommended) {
        priority <- NULL
        if (!base) 
            priority <- c("base", priority)
        if (!recommended) 
            priority <- c("recommended", priority)
        installed <- installed.packages(priority = priority)
    }
    else installed <- installed.packages()[FALSE, ]
    p0 <- p0[!miss]
    p1 <- p0
    not_avail <- character()
    repeat {
        deps <- apply(all.packages[p1, dependencies, drop = FALSE], 
            1L, function(x) paste(x[!is.na(x)], collapse = ", "))
        res <- .clean_up_dependencies2(deps, installed = installed, 
            all.packages)
        not_avail <- c(not_avail, res[[2L]])
        deps <- unique(res[[1L]])
        deps <- deps[!deps %in% c("R", pkgs)]
        if (!length(deps)) 
            break
        pkgs <- c(deps, pkgs)
        p1 <- deps
        if (!is.null(dep2)) {
            dependencies <- dep2
            dep2 <- NULL
        }
    }
    if (length(not_avail)) {
        not_avail <- unique(not_avail)
        warning(sprintf(ngettext(length(not_avail), "dependency %s is not available", 
            "dependencies %s are not available"), paste(sQuote(not_avail), 
            collapse = ", ")), domain = NA, call. = FALSE, immediate. = TRUE)
        flush.console()
    }
    pkgs <- unique(pkgs)
    pkgs <- pkgs[pkgs %in% row.names(all.packages)]
    p0 <- pkgs
    p0[!p0 %in% pkgs.in]
}




.LongNames <-
function(dframe){
  nm=deparse(substitute(dframe))
  hobject=get(paste(".",nm, sep=""))
  langNo=match(hobject$Language, hobject$Languages)
  lnames=hobject$LongNames
  unlist(lapply(lnames, function(x)x[langNo]))
	}
.ShortNames <-
function(dframe){ 
  nm=deparse(substitute(dframe))
  hobject=get(paste(".",nm, sep=""))
  hobject$ShortNames
	}


.Units <-
function(dframe){
  nm=deparse(substitute(dframe))
  hobject=get(paste(".",nm, sep=""))
  langNo=match(hobject$Language, hobject$Languages)
  lnames=hobject$Units
  unlist(lapply(lnames, function(x)x[langNo]))
	}

.Aux <-
function(dframe){ 
  nm=deparse(substitute(dframe))
  hobject=get(paste(".",nm, sep=""))
  hobject$Aux
	}

.ID <-
function(dframe){ 
  nm=deparse(substitute(dframe))
  hobject=get(paste(".",nm, sep=""))
  hobject$ID
	}


.hCriterion <-
function(n1=3, n2=3){
	
	oldpar=par(mfrow=c(n1,n2))
	
	source("horizontality.R", local=T)
	
	x=rownames(horizontality)
	names=colnames(horizontality)
	
	N=ncol(horizontality)
	n=n1*n2
	k=floor(N/n)
	if( N !=n*k ) k=k+1
	
	xlab=paste( "time lag to", attr(horizontality, "contrast"))
	
	for(j in 1:k){
		from=(j-1)*n+1
		to=min(N, j*n)             
		for(i in from:to)
		plot(x, horizontality[,i], main=names[i], cex=0.8, xlab=xlab, ylab="horizontality", type="l")
		
		if(j!=k) readline( "Hit Return to Next Page")
		
	}
	
	par(oldpar)
}




attach( list(q=.q, Setwd=setwd,  setwd=.setwd, txp=.txp, txp.data.frame=.txp.data.frame, 
txp.lm=.txp.lm, txp.default=.txp.default, packages=.packages, getDependencies=.getDependencies,
                    LongNames=.LongNames, ShortNames=.ShortNames, Units=.Units, Aux=.Aux, ID=.ID, hCriterion=.hCriterion ), name="TRAD", warn.conflicts = FALSE)

remove(.q, .setwd, .txp,  .txp.data.frame,  .txp.lm, .txp.default, .packages, .getDependencies, .LongNames, .ShortNames, .Units, .Aux, .ID, .hCriterion)


